#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter_administration.cgi,v 0.00.0.1 2013/05/07 ShelbyGT500
#

# Add entry in menu
# MENUENTRY copfilter 130 "Administration" "copfilter menu_administration"
#
# Make sure translation exists $Lang::tr{'copfilter menu_administration'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $restoremessage = '';
$copfiltersettings{'ACTION'} = '';
$copfiltersettings{'UPDATEFILE'}='';
my $OPTCOL = '';

my $output_monit = '';
my $output_p3scan = '';
my $output_proxsmtp = '';
my $output_squid = '';
my $output_havp = '';
my $output_privoxy = '';
my $output_frox = '';
my $output_spamassassin = '';
my $output_clamav = '';
my $output_imspector = '';
my $output_cicap = '';
my $output_renattach = '';




$output_monit = `/var/log/copfilter/default/opt/monit/default/bin/monit -V |head -1|sed -e 's/.* \\([.0-9]*\\)/\\1/'`;
$output_p3scan = `/var/log/copfilter/default/opt/p3scan/default/sbin/p3scan -v |sed  -n 's/P3Scan //p'`;
$output_proxsmtp = `/var/log/copfilter/default/opt/proxsmtp/default/sbin/proxsmtpd -v |sed  -n 's/.*version //p'  |sed -e 's/)//'`;
$output_squid = `/usr/sbin/squid -v |grep -E "Squid Cache: Version"| cut -d " " -f4`;
$output_havp = `LD_LIBRARY_PATH=/var/log/copfilter/default/opt/clamav/default/lib /var/log/copfilter/default/opt/havp/default/sbin/havp -h |grep Version|sed -e 's/HAVP Version \\(.*\\)/\\1/'`;
$output_privoxy = `/var/log/copfilter/default/opt/privoxy/default/sbin/privoxy --version |sed -e 's/.* \\([0-9].*[0-9a-zA-Z]\\) .*/\\1/'`;
$output_frox = `cat /var/log/copfilter/default/opt/frox/CURRENTVERSION`;
$output_spamassassin = `/var/log/copfilter/default/opt/mail-spamassassin/default/bin/spamc -V |sed -e 's/.* \\([0-9].*\\)/\\1/'`;
$output_clamav = `/var/log/copfilter/default/opt/clamav/default/sbin/clamd -V |sed -e 's/.* \\([0-9].*\\)\\/.*/\\1/'`;
$output_imspector = `ls -al /var/log/copfilter/default/opt/imspector | grep default | sed -e 's|\/| |g' | awk '{ print \$17 }'`;
$output_cicap = `ls -al /var/log/copfilter/default/opt/c_icap | grep default | sed -e 's|\/| |g' | awk '{ print \$17 }'`;
$output_renattach = `/var/log/copfilter/default/opt/tools/bin/renattach -V |sed -n '/renattach/p'|sed -e 's/.* \\(.*\\)/\\1/'`;


my $thrdp_clamav = system ('/bin/grep "THRDP_VERSION" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $thrdp_privoxy = system ('/bin/grep "RULES_VERSION" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $thrdp_virus = system ('/bin/grep "AVG_MOD" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $adminmod = system ('/bin/grep "ADMIN_VERSION" /var/log/copfilter/default/etc/global_settings &>/dev/null 2>&1');
my $thrdp_sarules = system ('/bin/grep "RDJ_VERSION" /var/log/copfilter/default/opt/tools/bin/check-updates_rulesdujour.sh &>/dev/null 2>&1');
my $thrdp_mod_on = ''; 



my %mainsettings = ();
&General::readhash('/var/ipcop/main/settings', \%mainsettings);


$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("/var/ipcop/ethernet/settings", \%netsettings);
&General::readhash("/var/log/copfilter/default/etc/global_settings", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("/var/log/copfilter/default/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


#&Header::showhttpheaders();
#&Header::openpage('Copfilter', 1, '');





################################################################################
##   ADMIN
################################################################################





##########################   Back up    ###############


#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
#&Header::getcgihash(\%copfiltersettings);
&General::getcgihash(\%copfiltersettings);
use File::Copy;


	if ($copfiltersettings{'ACTION'} eq 'COPFILTER V2 ---> [ . ]')	

#	if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter admin_create new backup'})
	{
		
		
		mkdir("/tmp/backup");
#		system("tar -czf '/tmp/backup/copfilterV2-backup.tar.gz' '${copfilter_swroot}/opt/backup/valid' '${copfilter_swroot}/opt/havp/etc/blacklist' '${copfilter_swroot}/opt/havp/etc/whitelist' '${copfilter_swroot}/etc' '${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt' '${copfilter_swroot}/opt/c_icap/etc/denydomains.txt' '${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt'"); 

		`tar -czf '/tmp/backup/copfilterV2-backup.tar.gz' '${copfilter_swroot}/opt/backup/valid' '${copfilter_swroot}/opt/havp/etc/blacklist' '${copfilter_swroot}/opt/havp/etc/whitelist' '${copfilter_swroot}/etc' '${copfilter_swroot}/opt/c_icap/etc/urlscanexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/avscansourceexceptions.txt' '${copfilter_swroot}/opt/c_icap/etc/allowdomains.txt' '${copfilter_swroot}/opt/c_icap/etc/denydomains.txt' '${copfilter_swroot}/opt/c_icap/etc/avscanexceptions.txt'`; 



			print "Content-type: application/gzip\n";
			print "Content-length: ";

			print (-s "/tmp/backup/copfilterV2-backup.tar.gz");

			print "\n";
			print "Content-disposition: attachment; filename=copfilterV2-backup.tar.gz\n\n";
			open (FILE, "/tmp/backup/copfilterV2-backup.tar.gz");

			while (<FILE>) { print; }
			close (FILE);



			exit;

		
	}

##########################   Restore    ###############

	if ($copfiltersettings{'ACTION'} eq '[ . ] ---> COPFILTER V2')
	{
		&General::getcgihash(\%copfiltersettings, {'wantfile' => 1, 'filevar' => 'UPDATEFILE'});


		if (!($copfiltersettings{'UPDATEFILE'} =~ /.tar.gz$/))
		{


#			$errormessage = $Lang::tr{'copfilter admin_invalid restore file'};
			$errormessage = $Lang::tr{'save error'};
#			$errormessage = 'INVALID RESTORE FILE ! ';


			print "$errormessage";

		}
		else
		{
			#sub copfilter_set_lang {


			$restoremessage = 'Changes will take effect within 5 minutes...';
			print "$restoremessage";

		}

	
		mkdir("/tmp/restore");
		copy($copfiltersettings{'UPDATEFILE'},"/tmp/restore/restore.tar.gz");
		system("/bin/tar --no-same-owner --preserve-permissions -xzf /tmp/restore/restore.tar.gz -C /tmp/restore");
			
	}








################################################################################
##  ERROR/RESTORE MESSAGE - DON'T MOVE HEADER TO PREVENT ISSUES
################################################################################



#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');
&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
#    print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}


if ($restoremessage) {
    &Header::openbox('100%', 'left',$Lang::tr{'backup'});

    #print "<class name='base'><font color='${Header::colourred}'>$restoremessage\n</font>";
    print "<font class='base'>$restoremessage&nbsp;</font>\n";
    &Header::closebox();
}




################################################################################
##   Use langs files -DON'T MOVE TO PREVENT ISSUES 
################################################################################

#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("/var/ipcop/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();







################################################################################
##   ACTIONs
################################################################################


################################################################################
##   set update values
################################################################################






################################################################################
##   purge enable and update files
################################################################################









################################################################################
##   Substitutions
################################################################################


sub downloadver
{
        my %proxysettings=();
        &General::readhash("/var/ipcop/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}




sub downloadver2
{
        my %proxysettings=();
        &General::readhash("/var/ipcop/proxy/settings", \%proxysettings);

        my $peer = 'shelby.eurowireless.de';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://shelby.eurowireless.de/update/UPDATE-V2 HTTP/1.1\r\n";
#	 $GET_CMD .= "User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 4.0)\r\n";
	 $GET_CMD .= "User-Agent: None\r\n";
        $GET_CMD .= "Host: shelby.eurowireless.de\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}
















################################################################################
##  Website ADMINISTRATION
################################################################################


print "<a name='Administration'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter menu_administration'} ");


#print "<form method='post' action='/cgi-bin/copfilter_administration.cgi' enctype='multipart/form-data'>";
print "<form method='post' action='$ENV{'SCRIPT_NAME'}' enctype='multipart/form-data'>\n";



print <<END
<img src='/images/web-support.png'>

<table width='100%' border='0' cellpadding='5'>

	<td colspan='4' class='base'><b>$Lang::tr{'copfilter update'}</b></td>

<tr>
        <td width='10%' colspan='1'><b>$Lang::tr{'copfilter product'}</b></td>
        <td width='20%' align='center' colspan='2'><b>$Lang::tr{'copfilter version'}</b></td>
        <td width='20%' align='center' colspan='3'><b>$Lang::tr{'copfilter latestversion'}</b></td>
        <td width='20%' align='center' colspan='4'><b>$Lang::tr{'copfilter status'}</b></td>

</tr>
<br />
<br />
</table>
END
;

my $return = &downloadver();
my @latest2 = split(/;x;/,$return);
my @latest = split(/LATEST-VERSION-IS/,$latest2[1]);
$copfiltersettings{'LATESTVERSION'} = $latest[1];
my @latestbeta = split(/LATEST-BETA-VERSION-IS/,$return);
$copfiltersettings{'LATESTBETAVERSION'} = $latestbeta[1];
my $installedversion;
my @installedversion;



print <<END

<table width='100%' border='0' cellpadding='5'>

<tr>
        <td width='10%' colspan='1'>COPFILTER</td>
        <td width='20%' align='center' colspan='2'>$copfiltersettings{'VERSION'}</td>
        <td width='20%'align='center' colspan='3'>$copfiltersettings{'LATESTVERSION'}</td>
END
;

#if ($copfiltersettings{'LATESTVERSION'} == $copfiltersettings{'VERSION'}) {
if ( $copfiltersettings{'LATESTVERSION'} =~ /$copfiltersettings{'VERSION'}/ ) {
	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

my $return = &downloadver();
my @latest2 = split(/;x;/,$return);
my @latest = split(/LATEST-VERSION-IS/,$latest2[1]);
$copfiltersettings{'LATESTVERSION'} = $latest[1];
my @latestbeta = split(/LATEST-BETA-VERSION-IS/,$return);
$copfiltersettings{'LATESTBETAVERSION'} = $latestbeta[1];
my $installedversion;
my @installedversion;




#if ( $copfiltersettings{'LATESTBETAVERSION'} == $copfiltersettings{'VERSION'} ) {
if ( $copfiltersettings{'LATESTBETAVERSION'} =~ /$copfiltersettings{'VERSION'}/ ) {
	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {
	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}

print <<END
</tr>
<br />

</table>
<table width='100%' border='0' cellpadding='5'>

END
;






my $return1 = &downloadver2();
my @latestmonit2 = split(/;x;/,$return1);
my @latestmonit = split(/MONIT-IS/,$latestmonit2[1]);
$copfiltersettings{'LATESTMONIT'} = $latestmonit[1];

#### for testing only
#print $return1;

my @latestp3scan3 = split(/MONIT-IS/,$return1);
my @latestp3scan2 = split(/;x;/,$latestp3scan3[1]);
my @latestp3scan = split(/P3SCAN-IS/,$latestp3scan2[1]);
$copfiltersettings{'LATESTP3SCAN'} = $latestp3scan[1];

my @latestproxsmtp3 = split(/P3SCAN-IS/,$return1);
my @latestproxsmtp2 = split(/;x;/,$latestproxsmtp3[1]);
my @latestproxsmtp = split(/PROXSMTP-IS/,$latestproxsmtp2[1]);
$copfiltersettings{'LATESTPROXSMTP'} = $latestproxsmtp[1];

my @latestsquid3 = split(/PROXSMTP-IS/,$return1);
my @latestsquid2 = split(/;x;/,$latestsquid3[1]);
my @latestsquid = split(/SQUID-IS/,$latestsquid2[1]);
$copfiltersettings{'LATESTSQUID'} = $latestsquid[1];


my @latesthavp3 = split(/SQUID-IS/,$return1);
my @latesthavp2 = split(/;x;/,$latesthavp3[1]);
my @latesthavp = split(/HAVP-IS/,$latesthavp2[1]);
$copfiltersettings{'LATESTHAVP'} = $latesthavp[1];

my @latestprivoxy3 = split(/HAVP-IS/,$return1);
my @latestprivoxy2 = split(/;x;/,$latestprivoxy3[1]);
my @latestprivoxy = split(/PRIVOXY-IS/,$latestprivoxy2[1]);
$copfiltersettings{'LATESTPRIVOXY'} = $latestprivoxy[1];

my @latestfrox3 = split(/PRIVOXY-IS/,$return1);
my @latestfrox2 = split(/;x;/,$latestfrox3[1]);
my @latestfrox = split(/FROX-IS/,$latestfrox2[1]);
$copfiltersettings{'LATESTFROX'} = $latestfrox[1];

my @latestspamassassin3 = split(/FROX-IS/,$return1);
my @latestspamassassin2 = split(/;x;/,$latestspamassassin3[1]);
my @latestspamassassin = split(/SPAMASSASSIN-IS/,$latestspamassassin2[1]);
$copfiltersettings{'LATESTSPAMASSASSIN'} = $latestspamassassin[1];


my @latestimspector3 = split(/CLAMAV-IS/,$return1);
my @latestimspector2 = split(/;x;/,$latestimspector3[1]);
my @latestimspector = split(/IMSPECTOR-IS/,$latestimspector2[1]);
$copfiltersettings{'LATESTIMSPECTOR'} = $latestimspector[1];

my @latestcicap3 = split(/IMSPECTOR-IS/,$return1);
my @latestcicap2 = split(/;x;/,$latestcicap3[1]);
my @latestcicap = split(/CICAP-IS/,$latestcicap2[1]);
$copfiltersettings{'LATESTCICAP'} = $latestcicap[1];

my @latestrenattach3 = split(/AVAST-IS/,$return1);
my @latestrenattach2 = split(/;x;/,$latestrenattach3[1]);
my @latestrenattach = split(/RENATTACH-IS/,$latestrenattach2[1]);
$copfiltersettings{'LATESTRENATTACH'} = $latestrenattach[1];

my @latestclamav3 = split(/SPAMASSASSIN-IS/,$return1);
my @latestclamav2 = split(/;x;/,$latestclamav3[1]);
my @latestclamav = split(/CLAMAV-IS/,$latestclamav2[1]);
$copfiltersettings{'LATESTCLAMAV'} = $latestclamav[1];





print <<END

<table width='100%' border='0' cellpadding='5'>

<tr>
        <td width='10%' colspan='1'>Monit</td>
        <td width='20%' align='center' colspan='2'>$output_monit</td>
        <td width='20%'align='center' colspan='3'>$copfiltersettings{'LATESTMONIT'}</td>
END
;

if ( $copfiltersettings{'LATESTMONIT'} == $output_monit ) {
	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>P3Scan</td>
        <td width='20%' align='center' colspan='2'>$output_p3scan</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTP3SCAN'}</td>
END
;

if ( $output_p3scan =~ /$copfiltersettings{'LATESTP3SCAN'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>ProxSMTP</td>
        <td width='20%' align='center' colspan='2'>$output_proxsmtp</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTPROXSMTP'}</td>
END
;

if ( $output_proxsmtp =~ /$copfiltersettings{'LATESTPROXSMTP'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}



print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>Squid</td>
        <td width='20%' align='center' colspan='2'>$output_squid</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTSQUID'}</td>
END
;

if ( $output_squid =~ /$copfiltersettings{'LATESTSQUID'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>HAVP</td>
        <td width='20%' align='center' colspan='2'>$output_havp</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTHAVP'}</td>
END
;

if ( $output_havp =~ /$copfiltersettings{'LATESTHAVP'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>Privoxy</td>
        <td width='20%' align='center' colspan='2'>$output_privoxy</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTPRIVOXY'}</td>
END
;

if ( $output_privoxy =~ /$copfiltersettings{'LATESTPRIVOXY'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>Frox</td>
        <td width='20%' align='center' colspan='2'>$output_frox</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTFROX'}</td>
END
;

if ( $output_frox =~ /$copfiltersettings{'LATESTFROX'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>SpamAssassin</td>
        <td width='20%' align='center' colspan='2'>$output_spamassassin</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTSPAMASSASSIN'}</td>
END
;

if ( $output_spamassassin =~ /$copfiltersettings{'LATESTSPAMASSASSIN'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>Imspector</td>
        <td width='20%' align='center' colspan='2'>$output_imspector</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTIMSPECTOR'}</td>
END
;

if ( $output_imspector =~ /$copfiltersettings{'LATESTIMSPECTOR'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>C-ICAP</td>
        <td width='20%' align='center' colspan='2'>$output_cicap</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTCICAP'}</td>
END
;

if ( $output_cicap =~ /$copfiltersettings{'LATESTCICAP'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}

print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>Renattach</td>
        <td width='20%' align='center' colspan='2'>$output_renattach</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTRENATTACH'}</td>
END
;

if ( $output_renattach =~ /$copfiltersettings{'LATESTRENATTACH'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>ClamAV</td>
        <td width='20%' align='center' colspan='2'>$output_clamav</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTCLAMAV'}</td>
END
;

if ( $output_clamav =~ /$copfiltersettings{'LATESTCLAMAV'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}




if ($copfiltersettings{'AVG_INSTALLED'} eq 'yes' ) {
my $output_avg = '';
$output_avg = `cat /var/log/copfilter/default/opt/avg/CURRENTVERSION |sed -n '/version/p' |sed -e 's/AVG version	:  //g'`;

my @latestavg3 = split(/CICAP-IS/,$return1);
my @latestavg2 = split(/;x;/,$latestavg3[1]);
my @latestavg = split(/AVG-IS/,$latestavg2[1]);
$copfiltersettings{'LATESTAVG'} = $latestavg[1];


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>AVG</td>
        <td width='20%' align='center' colspan='2'>$output_avg</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTAVG'}</td>
END
;

if ( $output_avg =~ /$copfiltersettings{'LATESTAVG'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}




if ($copfiltersettings{'FPROT_INSTALLED'} eq 'yes' ) {
my $output_fprot = '';
$output_fprot = `/var/log/copfilter/default/opt/f-prot/default/fpscan --version | grep -E "^F-P" | cut -d "," -f1 | sed -e 's/[a-zA-Z -]//g'`;

my @latestfprot3 = split(/AVG-IS/,$return1);
my @latestfprot2 = split(/;x;/,$latestfprot3[1]);
my @latestfprot = split(/FPROT-IS/,$latestfprot2[1]);
$copfiltersettings{'LATESTFPROT'} = $latestfprot[1];


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>F-PROT</td>
        <td width='20%' align='center' colspan='2'>$output_fprot</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTFPROT'}</td>
END
;

if ( $output_fprot =~ /$copfiltersettings{'LATESTFPROT'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}




if ($copfiltersettings{'AVAST_INSTALLED'} eq 'yes' ) {
my $output_avast = '';
$output_avast = `cat 1p /var/log/copfilter/default/opt/avast/CURRENTVERSION |/bin/sed -n '/Version/p' |/bin/sed -e 's/AVAST Version//g'`;

my @latestavast3 = split(/FPROT-IS/,$return1);
my @latestavast2 = split(/;x;/,$latestavast3[1]);
my @latestavast = split(/AVAST-IS/,$latestavast2[1]);
$copfiltersettings{'LATESTAVAST'} = $latestavast[1];


print <<END
<tr/>
<tr>
        <td width='10%' colspan='1'>AVAST</td>
        <td width='20%' align='center' colspan='2'>$output_avast</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTAVAST'}</td>
END
;

if ( $output_avast =~ /$copfiltersettings{'LATESTAVAST'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>
END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}


if ( $thrdp_virus eq 0 || $thrdp_privoxy eq 0 || $adminmod eq 0 || $thrdp_sarules eq 0) {
print <<END

	<tr>
	<td colspan='3'>$Lang::tr{'copfilter mods'}</td> 
	</tr>
END
;


if ($thrdp_privoxy eq 0){
my $output_3rdprivoxy = '';
$output_3rdprivoxy = $copfiltersettings{'RULES_VERSION'};

my @latest3rdprivoxy3 = split(/RENATTACH-IS/,$return1);
my @latest3rdprivoxy2 = split(/;x;/,$latest3rdprivoxy3[1]);
my @latest3rdprivoxy = split(/PRIVOXYMOD-IS/,$latest3rdprivoxy2[1]);
$copfiltersettings{'LATESTPRIVOXYMOD'} = $latest3rdprivoxy[1];


print <<END

<tr/>
<tr>
        <td width='10%' colspan='1'>Privoxy Mod</td>
        <td width='20%' align='center' colspan='2'>$output_3rdprivoxy</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTPRIVOXYMOD'}</td>
END
;

if ( $output_3rdprivoxy =~ /$copfiltersettings{'LATESTPRIVOXYMOD'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>

END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}

if ($thrdp_virus eq 0){
my $output_3rdvirus = '';
$output_3rdvirus = $copfiltersettings{'AVG_MOD'};

my @latest3rdvirus3 = split(/PRIVOXYMOD-IS/,$return1);
my @latest3rdvirus2 = split(/;x;/,$latest3rdvirus3[1]);
my @latest3rdvirus = split(/VIRUSMOD-IS/,$latest3rdvirus2[1]);
$copfiltersettings{'LATESTVIRUSMOD'} = $latest3rdvirus[1];


print <<END

<tr/>
<tr>
        <td width='10%' colspan='1'>Virus Scanner Mod</td>
        <td width='20%' align='center' colspan='2'>$output_3rdvirus</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTVIRUSMOD'}</td>
END
;

if ( $output_3rdvirus =~ /$copfiltersettings{'LATESTVIRUSMOD'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>

END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}

if ($adminmod eq 0){
my $output_adminmod = '';
$output_adminmod = $copfiltersettings{'ADMIN_VERSION'};

my @latestadminmod3 = split(/VIRUSMOD-IS/,$return1);
my @latestadminmod2 = split(/;x;/,$latestadminmod3[1]);
my @latestadminmod = split(/ADMINMOD-IS/,$latestadminmod2[1]);
$copfiltersettings{'LATESTADMINMOD'} = $latestadminmod[1];


print <<END

<tr/>
<tr>
        <td width='10%' colspan='1'>Admin Mod</td>
        <td width='20%' align='center' colspan='2'>$output_adminmod</td>
        <td width='20%' align='center' colspan='3'>$copfiltersettings{'LATESTADMINMOD'}</td>
END
;

if ( $output_adminmod =~ /$copfiltersettings{'LATESTADMINMOD'}/ ) {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/ok.jpg' width='25' height='25' alt='*'></td>

END
;
}
else {

	print <<END
       <td width='20%' align='center' colspan='4'><img src='/images/danger2.jpg' width='25' height='25' alt='*'></td>
END
;

}
}




}
























print <<END


</tr>

</tr>


<tr>
 
    <td ><form method='post' >
    </form></td>
<td align='right' colspan='6'>
    <form method='post' action='http://www.copfilter.org/forum/viewtopic.php?f=9&t=895#p4629'>
    <input type='submit' value='$Lang::tr{'copfilter update'}' />
    </form></td>
</tr>

	<td nowrap> </td>
<tr>
        <td nowrap>&nbsp;</td>



</table>






<br />




<hr size='1'>

<table width='100%'>
<img src='/images/floppy.gif' >
<tr>
	<td colspan='4' class='base'><b>$Lang::tr{'copfilter admin_backup settings'}</b></td>
</tr>
<tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>
</tr>
<tr>
	<td colspan='4' class='base'><input type='submit' name='ACTION' value='COPFILTER V2 ---> [ . ]' />&nbsp; $Lang::tr{'copfilter admin_create new backup'}
</td>
</tr>
<tr>&nbsp; </tr>
<br />

</table>

<br />
<br />



<hr size='1'>

<table width='100%'>
</tr>
<img src='/images/reload.gif' >
<tr>&nbsp; </tr>
<br />

<tr>
	<td class='base'><b>$Lang::tr{'copfilter admin_restore settings'}</b></td>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>
	<td>$Lang::tr{'copfilter admin_restore text'}:***</td>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>
	<td><input type='file' name='UPDATEFILE' size='40' /> &nbsp; <input type='submit' name='ACTION' value='[ . ] ---> COPFILTER V2' />&nbsp; $Lang::tr{'copfilter admin_import'}</td>

</tr>
</tr>
         <td>&nbsp;</td>
        <td>&nbsp;</td>

<tr>

<td>$Lang::tr{'copfilter clamd thrdp_info'}</td>
<td nowrap colspan='2' nowrap> <b><font size='0.5em'>Admin mod version : $copfiltersettings{'ADMIN_VERSION'}<br> </b></td>
</table>
<br />
		

<br />
	<td nowrap valign='bottom' align='right'><img src='/images/copfilter-logo.png' width='120' height='48' alt='*'></td>

</form>


END
;

print "</form>\n";
&Header::closebox();
print "<br />\n";

# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


